package sbc.mgclus.writer;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

import org.apache.log4j.Logger;
import org.jgrapht.WeightedGraph;
import org.jgrapht.graph.DefaultWeightedEdge;

import sbc.mgclus.algorithm.ClusteringKL;
import sbc.mgclus.data.Cluster;
import sbc.mgclus.data.Vertex;


public class OutputWriterTSV {
	private WeightedGraph<Cluster, DefaultWeightedEdge> graph;
	private File outputFile;
	private Logger logger=Logger.getLogger(ClusteringKL.class);
	
	public OutputWriterTSV(WeightedGraph<Cluster, DefaultWeightedEdge> g, File f){
		graph = g;
		outputFile = f;
	}
	
	public void outputClusterTSV (){
        try {
        	logger.info(String.format("output will be we written to: %s\n", outputFile));
			FileWriter out = new FileWriter(outputFile);
			//write each cluster as one line in the result file
			ArrayList<Cluster> clusterList = new ArrayList<Cluster>(graph.vertexSet());
			Collections.sort(clusterList);
			for (Cluster c : clusterList){
				if (!(c.getClusterSize() < 2)){
					String line = "";
					for (Vertex v : c.getMembers()){
						line += String.format("%s\t", v.getName());
					}
					line += "\n";
					out.write(line);
				}
				else
					break;
			}
			out.close();
		} catch (IOException ex) {
			logger.error("an error occurred while writting the result file (file could not be created)");
			ex.printStackTrace();
			System.exit(1);
		}
	}
}
